const config = require('../../config');
const providers = config.providers;
const crypto = require('crypto');
const bcrypt = require('bcrypt');
const moment = require('moment');

module.exports = function (sequelize, DataTypes) {
  const inventory_events = sequelize.define(
    'inventory_events',
    {
      id: {
        type: DataTypes.UUID,
        defaultValue: DataTypes.UUIDV4,
        primaryKey: true,
      },

      event_type: {
        type: DataTypes.ENUM,

        values: ['Assigned', 'Returned', 'Repaired'],
      },

      timestamp: {
        type: DataTypes.DATE,
      },

      metadata: {
        type: DataTypes.TEXT,
      },

      importHash: {
        type: DataTypes.STRING(255),
        allowNull: true,
        unique: true,
      },
    },
    {
      timestamps: true,
      paranoid: true,
      freezeTableName: true,
    },
  );

  inventory_events.associate = (db) => {
    /// loop through entities and it's fields, and if ref === current e[name] and create relation has many on parent entity

    //end loop

    db.inventory_events.belongsTo(db.devices, {
      as: 'device',
      foreignKey: {
        name: 'deviceId',
      },
      constraints: false,
    });

    db.inventory_events.belongsTo(db.organizations, {
      as: 'organizations',
      foreignKey: {
        name: 'organizationsId',
      },
      constraints: false,
    });

    db.inventory_events.belongsTo(db.users, {
      as: 'createdBy',
    });

    db.inventory_events.belongsTo(db.users, {
      as: 'updatedBy',
    });
  };

  return inventory_events;
};
